<template>
  <single-panel>
    <div class="delete-panel" v-if="selectedAgents.length">
      <span>
        {{ declOfNum(selectedAgents.length, 'Выбрана | Выбрано | Выбрано') }} {{ plural(selectedAgents.length, 'запись | записи | записей') }}
      </span>
      <span class="delete-panel__button" @click="confirmDelete">
        <i class="icon delete"></i>
        Исключить из списка заблокированных
      </span>
    </div>
    <div class="delete-table">
      <ob-table
        :columns="agentsColumns"
        :functionalPanel="true"
        :remote-opt="{
          method: getAgents
        }"
        :tableLayoutFixed="false"
        :show-add-button="true"
        add-button-text="Заблокировать контрагента "
        data-qa="LogisticDomainsAgentsTable"
        @select="onSelect"
        @add="onAdd"
        ref="obTableAllAgents"
        is-fixed-header
        :is-functional-sort="false"
        :is-functional-group="false"
      >
        <template v-slot:checkbox="{ data }">
          <div @click.stop>
            <ob-checkbox
              v-model="data.item.checked"
              @change="toggleAgent(data.item)"
            />
          </div>
        </template>
        <template v-slot:type="{ data }">
          <i :class="['icon', $options.rolesMap[data.item.roleCode]]"></i>
        </template>
        <template v-slot:status="{ data }">
          <div :class="['status', data.item.status === 'онлайн' ? 'is-online' : '']">
            {{data.item.status}}
          </div>
        </template>
        <template v-slot:risk="{ data }">
          <i :class="['icon', $options.riskColorsMap[data.item.riskColor]]"></i>
        </template>
        <template v-slot:linkType="{ data }">
          <i class='icon close'></i>
        </template>
        <template v-slot:files="{ data }">
          <div class="link">
            <i class="icon attach"></i>
          </div>
        </template>
        <template slot="noneContent">
          <div class="no-content">
            <p>Ограничьте нежелательным контрагентам доступ к вашим заказам, занесите их в список заблокированных контрагентов</p>
            <span @click="onAdd">Заблокировать контрагента</span>
          </div>
        </template>
      </ob-table>
    </div>
    <ob-modal
      ref="addAgentModal"
      title="Добавление контрагента в заблокированные"
      :is-show-controls="false"
      size="max"
      @opened="onOpened"
    >
      <AgentModal
        ref="addModal"
        :agentsToFilter="agentsToFilter"
        @submitted="onSubmittedForm"
        :data-source="newAgents"
      />
    </ob-modal>

    <ob-modal
      ref="agentModal"
      size="medium"
      isShowControls
      :isSubmitDisabled="activeTableAgent && activeTableAgent.checked"
      okText="Выбрать"
      @submit="onSelectAgent"
      cancelText="Отменить"
    >
      <div class="title" slot="title" v-if="activeAgent">
        <div class="title__second">
          экспедитор
          <span :class="['status', activeAgent.status === 'онлайн' ? 'is-online' : '']">
            {{activeAgent.status}}
          </span>
        </div>
        <div class="ob-ty-modal-title">
          <i :class="['icon', $options.rolesMap[activeAgent.roleCode]]"></i>
          {{activeAgent.title}}
        </div>
      </div>
      <agent-info
        :agent="activeAgent"
      />
    </ob-modal>

    <ob-modal
      ref="deleteAgentsModal"
      title="Исключить из списка заблокированных "
      size="medium"
      :is-show-controls="true"
      ok-text="Исключить  "
      @submit="onDeleteGroupAgents"
    >
      Вы точно хотите удалить {{ plural(selectedAgents.length, 'контрагента | контрагентов | контрагентов') }}?
    </ob-modal>
  </single-panel>
</template>

<script>
  import api from '@/api';
  import SinglePanel from "common-components/src/obComponents/obSinglePanels";
  import ObTable from "common-components/src/obComponents/obTable";
  import ObCheckbox from "common-components/src/obComponents/obCheckbox";
  import ObModal from "common-components/src/obComponents/obModal";
  import AgentInfo from "./components/agentInfo";
  import AgentModal from "./components/addAgentModal";

  export default {
    name: 'logistic_domains_blocked',

    rolesMap: {
      'CLIENT': 'role-client',
      'CLICAR': 'role-domain-owner',
      'CARRIER': 'role-agent'
    },

    riskColorsMap: {
      'GREEN': 'risk-1-blue',
      'BLUE': 'risk-2-green',
      'YELLOW': 'risk-3-yellow',
      'ORANGE': 'risk-4-orange',
      'RED': 'risk-5-red',
      'BLACK': 'risk-6-black'
    },

    components: {
      SinglePanel,
      ObTable,
      ObCheckbox,
      ObModal,
      AgentInfo,
      AgentModal,
    },

    data() {
      return {
        newAgents: {
          agents: []
        },
        activeAgent: null,
        activeTableAgent: null,
        selectedAgents: [],
        groupId: '',
        agentsToFilter: []
      }
    },

    computed: {
      agentsColumns() {
        return [
          {
            slotName: 'checkbox',
            isToggleDisabled: true
          },
          {
            title: 'Тип',
            key: 'roleCode',
            slotName: 'type'
          },
          {
            title: 'название контрагента',
            key: 'title',
          },
          {
            title: 'присутствие в системе',
            key: 'status',
            slotName: 'status'
          },
          {
            title: 'группа риска',
            key: 'riskColor',
            slotName: 'risk'
          },
          {
            title: 'рейтинг',
            key: 'rating'
          },
          {
            title: 'скоринг',
            key: 'scoring'
          },
          {
            title: 'тип линка',
            key: 'linkType',
            slotName: 'linkType'
          },
          {
            title: 'инн',
            key: 'inn'
          },
          {
            title: 'телефон',
            key: 'phone'
          },
          {
            title: 'эл. почта',
            key: 'email'
          },
          {
            title: 'юридический адрес',
            key: 'legalAddress'
          },
          {
            title: 'описание',
            key: 'description'
          },
          {
            title: 'files',
            slotName: 'files'
          }
        ]
      }
    },

    methods: {
      onOpened() {
        this.$nextTick(() => {
          this.$refs.addModal.init();
        })
      },

      onSelectAgent() {
        this.activeTableAgent.checked=true;
        this.toggleAgent(this.activeTableAgent);
        this.$refs.agentModal.close();
      },

      async getAgents({ page, size, sort="title,desc", query, group_type }) {
        const altSort = sort?.split(',')
        try {
          let res = await api.linkBrowser.getAllBlockedAgents({ page, size, sort: altSort[0], direction: altSort[1], query, group_type });
          this.groupId = res.groupUuid;
          this.agentsToFilter = res.content.map(item => item.uuid);
          res.content = res.content.map(item => {
            return { ...item, status: '—', checked: false, description: '—'}
          });
          return res;
        } catch (err) {
          console.error(err);
        }
      },

      async onSelect(agent) {
        this.activeTableAgent = agent;
        await this.getAgent(agent.uuid);
        this.$refs.agentModal.open();
      },

      async getAgent(uuid) {
        const res = await api.linkBrowser.getAgent(uuid);
        res.status = 'онлайн';
        this.activeAgent = res;
      },

      async onAdd() {
        this.$refs.addAgentModal.open();
      },

      toggleAgent(agent) {
        if (agent.checked) {
          this.selectedAgents.push(agent);
        } else {
          if (this.selectedAgents.some(item => item.uuid === agent.uuid)) {
            const target = this.selectedAgents.indexOf(agent);
            this.selectedAgents.splice(target, 1);
          }
        }
      },

      async onSubmittedForm($event) {
        const payload = $event.map(item => item.uuid);
        try {
          await api.linkBrowser.addGroupAgent(this.groupId, payload);
          this.$refs.addAgentModal.close();
          this.$refs['obTableAllAgents'].loadData({ init: true });
        } catch (err) {
          console.error(err);
        }
      },

      confirmDelete() {
        this.$refs.deleteAgentsModal.open();
      },

      async onDeleteGroupAgents() {
        const payload = this.selectedAgents.map(item => item.uuid);
        try {
          await api.linkBrowser.deleteGroupAgent(this.groupId, payload);
          this.selectedAgents = [];
          this.$refs.deleteAgentsModal.close();
          this.$refs['obTableAllAgents'].loadData({ init: true });
        } catch (err) {
          console.error(err);
        }
      },

      plural(value, unit) {
        return `${value} ${this.declOfNum(value, unit)}`;
      },

      declOfNum(n, string) {
        let titles = string.split("|");
        return titles[
          n % 10 == 1 && n % 100 != 11
            ? 0
            : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
            ? 1
            : 2
        ];
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

  .left {
    margin: 20px;
    position: relative;
  }

  .delete-table {

    height: 100%;

    &::v-deep {
      td:nth-child(3),
      td:nth-child(6),
      td:nth-child(7),
      td:nth-child(9),
      td:nth-child(10),
      td:nth-child(11),
      td:nth-child(12),
      td:nth-child(13),
      td:nth-child(14) {
        color: $gray-window;
        text-decoration: line-through;
      }

      td:nth-child(2) {
        color: $gray-window;
      }

      td:nth-child(8) > .td-container {
        font-size: 10px;
        color: $color-error;
        display: flex;
        justify-content: center;
      }
    }
  }


  .no-content {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    max-width: 870px;

    p {
      @include font-mixin(24px, 40px, 400, $color-grey-span);
    }

    span {
      margin-top: 20px;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
      text-decoration: none;
      cursor: pointer;
    }
  }

  .delete-panel {
    position: absolute;
    left: 0;
    top: 0;
    width: 70%;
    z-index: 1;
    display: flex;
    align-items: center;
    height: 60px;
    padding: 0 21px;
    background: #fff;
    @include font-mixin(16px, 20px, 400, $color-text-base );
  }

  .delete-panel__button {
    display: flex;
    align-items: center;
    margin-left: 12px;
    color: $color-error;
    cursor: pointer;

    i {
      margin-right: 5px;
    }
  }

</style>